#include "Print.h"
#include "Vram.h"

static bool zeroVisible, first;
static byte byteValue;
static word wordValue;

void PrintS(word vram, bool shift, ptr<byte> p)
{
    byte c;
    Locate(vram, shift);
    while ((c = *p) != 0) {
        PrintC(c);
        ++p;
    }
}

static void PrintDigitB(byte n)
{
    byte c;
    c = 0;
    while (byteValue >= n) {
        ++c;
        byteValue -= n;
    }
    if (c == 0) {
        c = zeroVisible ? '0' : ' ';
    }
    else {
        zeroVisible = true;
        c += '0';
    }
    if (c != ' ' || first) {
        PrintC(c);
        first = false;
    }
}

void PrintByteNumber3(word vram, bool shift, byte b)
{
    Locate(vram, shift);
    zeroVisible = false;
    first = true;
    byteValue = b;
    PrintDigitB(100);
    PrintDigitB(10);
    PrintC(byteValue + '0');
}

void PrintByteNumber2(word vram, bool shift, byte b)
{
    Locate(vram, shift);
    zeroVisible = false;
    first = true;
    byteValue = b;
    PrintDigitB(10);
    PrintC(byteValue + '0');
}


static void PrintDigitW(word n)
{
    byte c;
    
    c = 0;
    while (wordValue >= n) {
        ++c;
        wordValue -= n;
    }
    if (c == 0) {
        c = zeroVisible ? '0' : ' ';
    }
    else {
        zeroVisible = true;
        c += '0';
    }
    if (c != ' ' || first) {
        PrintC(c);
        first = false;
    }
}

void PrintNumber5(word vram, bool shift, word w)
{
    Locate(vram, shift);
    zeroVisible = false;
    first = true;
    wordValue = w;
    PrintDigitW(10000);
    PrintDigitW(1000);
    PrintDigitW(100);
    PrintDigitW(10);
    PrintC(wordValue + '0');
}

void PrintNumber3(word vram, bool shift, word w)
{
    Locate(vram, shift);
    zeroVisible = false;
    first = true;
    wordValue = w;
    PrintDigitW(100);
    PrintDigitW(10);
    PrintC(wordValue + '0');
}
